#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/stat.h>
#include <pwd.h>

int main (int argc, char *argv[])
{
	int ret = -1;
	if (argc != 2){
		fprintf (stderr,"fileowner file\nPrint the owner of a file\n");
	}else{
		struct stat st;
		if (stat (argv[1],&st)!=-1){
			struct passwd *p = getpwuid (st.st_uid);
			if (p != NULL){
				printf ("%s\n",p->pw_name);
				ret = 0;
			}else{
				fprintf (stderr,"No corresponding user name for user id %d\n"
					,st.st_uid);
			}
		}else{
			fprintf (stderr,"Can't stat file %s (%s)\n",argv[1]
				,strerror(errno));
		}
	}
	return ret;
}

